#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <cstrike>
#include <fun>
#include <cvi>
#include <amx_settings_api>

#define LINUX_WEAPON_OFF    4
#define LINUX_PLAYER_OFF    5
#define m_flStartThrow     30
#define m_flReleaseThrow   31
#define m_pPlayer          41
#define m_flTimeWeaponIdle 48
#define m_LastHitGroup     75

new g_iKillCount[33][2], g_iSelfGrenade[33];
new cvar_cowboy_normal_health, cvar_cowboy_normal_armor, cvar_cowboy_upgrade_kills, cvar_grenade_explode_wait, cvar_grenade_damage_multi;
new cvar_cowboy_upgrade_hskills, cvar_cowboy_upgrade_health, cvar_cowboy_upgrade_armor, cvar_cowboy_upgrade_extrahp;
new g_pMsgScreenFade, g_pSprite;
new g_szSound[CVI_MAXFILELENGHT];
new g_szGrenadeModels[3][CVI_MAXFILELENGHT];

public plugin_precache()
{
  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Upgrade Sounds", "COWBOY", g_szSound, charsmax(g_szSound)))
  {
    g_szSound = "cvi/cowboy.wav";
    amx_save_setting_string(CVI_SETTINGSFILE, "Upgrade Sounds", "COWBOY", g_szSound);
  }
  precache_sound(g_szSound);
  g_pSprite = precache_model("sprites/laserbeam.spr");

//GRENADE
  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Cowboy", "GRENADE_MODEL_V", g_szGrenadeModels[0], charsmax(g_szGrenadeModels[])))
  {
    g_szGrenadeModels[0] = "models/cvi/v_nitroglycerin.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Indian", "GRENADE_MODEL_V", g_szGrenadeModels[0]);
  }
  precache_model(g_szGrenadeModels[0]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Cowboy", "GRENADE_MODEL_P", g_szGrenadeModels[1], charsmax(g_szGrenadeModels[])))
  {
    g_szGrenadeModels[1] = "models/cvi/p_nitroglycerin.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Cowboy", "GRENADE_MODEL_P", g_szGrenadeModels[1]);
  }
  precache_model(g_szGrenadeModels[1]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Cowboy", "GRENADE_MODEL_W", g_szGrenadeModels[2], charsmax(g_szGrenadeModels[])))
  {
    g_szGrenadeModels[2] = "models/cvi/w_nitroglycerin.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Cowboy", "GRENADE_MODEL_W", g_szGrenadeModels[2]);
  }
  precache_model(g_szGrenadeModels[2]);
//END
}

public plugin_init()
{
  register_plugin("[CVI] Class: Cowboy", CVI_VERSION, CVI_AUTHOR);

  cvar_cowboy_upgrade_kills   = my_register_cvar("cvi_cowboy_upgrade_kills", "3", "Number of normal kills needed to upgrade. (Default: 3)");
  cvar_cowboy_upgrade_hskills = my_register_cvar("cvi_cowboy_upgrade_hskills", "1", "Number of headshot kills needed to upgrade. (Default: 1)");
  cvar_cowboy_normal_health   = my_register_cvar("cvi_cowboy_normal_health", "20", "Amount of extra health as normal cowboy. (Default: 20)");
  cvar_cowboy_normal_armor    = my_register_cvar("cvi_cowboy_normal_armor", "50", "Amount of armor as normal cowboy. (Default: 50)");
  cvar_cowboy_upgrade_health  = my_register_cvar("cvi_cowboy_upgrade_health", "50", "Amount of extra health as upgraded cowboy. (Default: 50)");
  cvar_cowboy_upgrade_armor   = my_register_cvar("cvi_cowboy_upgrade_armor", "100", "Amount of armor as upgraded cowboy. (Default: 100)");
  cvar_cowboy_upgrade_extrahp = my_register_cvar("cvi_cowboy_upgrade_extrahp", "15", "Amount of health regained upon a kill. (Default: 15)");
  cvar_grenade_explode_wait   = my_register_cvar("cvi_grenade_explode_wait", "2.0", "Time before grenade explodes in hand. (Default: 2.0)");
  cvar_grenade_damage_multi   = my_register_cvar("cvi_grenade_damage_multi", "1.4", "Grenade damage multiplier. (Default: 1.4)");

  RegisterHamPlayer(Ham_Killed, "Ham_Killed_pre", 0);
  RegisterHamPlayer(Ham_TakeDamage, "Ham_TakeDamage_pre", 0);

  RegisterHam(Ham_Item_Deploy, "weapon_hegrenade", "Ham_Item_Deploy_post", 1);
  RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_hegrenade", "Ham_PrimaryAttack_post", 0);
  g_pMsgScreenFade = get_user_msgid("ScreenFade");
}

public client_disconnect(id)
{
  g_iKillCount[id][0] = 0;
  g_iKillCount[id][1] = 0;
}

public cvi_gamemode(mode)
{
  if(mode == GAME_STARTED)
  {
    new num, id, cvars[4];
    cvars[0] = get_pcvar_num(cvar_cowboy_upgrade_hskills);
    cvars[1] = get_pcvar_num(cvar_cowboy_upgrade_kills);
    cvars[2] = get_pcvar_num(cvar_cowboy_normal_health);
    cvars[3] = get_pcvar_num(cvar_cowboy_normal_armor);
    static players[32];
    get_players(players, num);

    for(--num; num >= 0; num--)
    {
      id = players[num];
      g_iKillCount[id][0] = 0;
      g_iKillCount[id][1] = 0;
      if(is_user_alive(id) && is_cowboy(id))
      {
        client_print_color(id, print_team_default, "%s %L", CVI_TAG, id, "CVI_NEEDTO_C", cvars[0], cvars[1]);
        set_user_extrahealth(id, cvars[2]);
        cs_set_user_armor(id, cvars[3], CS_ARMOR_VESTHELM);
      }
    }
  }
}

public grenade_throw(id, ent, nade)
{
  if(nade == CSW_HEGRENADE && is_user_alive(id) && is_cowboy(id) && is_upgraded(id))
  {
    if(task_exists(id))
      remove_task(id);

    if(pev(ent, pev_dmgtime) != 0.0)
    {
      engfunc(EngFunc_SetModel, ent, g_szGrenadeModels[2]);
      if(g_iSelfGrenade[id])
      {
        g_iSelfGrenade[id] = false;
        set_pev(ent, pev_dmgtime, get_gametime());
        set_pev(ent, pev_nextthink, get_gametime());
      }
    }
  }
}

public Ham_TakeDamage_pre(victim, inflictor, attacker, Float:damage, bits)
{
  if(is_user_connected(attacker) && bits & (1 << 24))
  {
    SetHamParamFloat(4, damage * get_pcvar_float(cvar_grenade_damage_multi));
    return HAM_HANDLED;
  }

  return HAM_IGNORED;
}

public Ham_PrimaryAttack_post(ent)
{
  new id = get_pdata_cbase(ent, m_pPlayer, LINUX_WEAPON_OFF);
  if(is_user_alive(id) && is_cowboy(id) && is_upgraded(id))
  {
    if(!task_exists(id) && get_pdata_float(ent, m_flStartThrow, LINUX_WEAPON_OFF))
      set_task(get_pcvar_float(cvar_grenade_explode_wait), "explode_grenade", id);
  }
}

public explode_grenade(id)
{
  g_iSelfGrenade[id] = true;
  new ent = fm_find_ent_by_owner(-1, "weapon_hegrenade", id);
  ExecuteHam(Ham_Weapon_PrimaryAttack, ent);
  set_pdata_float(ent, m_flTimeWeaponIdle, 0.0, LINUX_WEAPON_OFF);
  ExecuteHam(Ham_Weapon_WeaponIdle, ent);
}

public Ham_Item_Deploy_post(ent)
{
  new id = get_pdata_cbase(ent, m_pPlayer, LINUX_WEAPON_OFF);
  if(is_user_alive(id) && is_cowboy(id) && is_upgraded(id))
  {
    set_pev(id, pev_viewmodel2, g_szGrenadeModels[0]);
    set_pev(id, pev_weaponmodel2, g_szGrenadeModels[1]);
  }
}

public Ham_Killed_pre(victim, killer, shouldgib)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  if(is_user_alive(killer))
  {
    new upgrade = is_upgraded(killer);
    if(!upgrade && is_upgraded(victim))
      cvi_set_playerdata(killer, PD_UPGRADE, upgrade = true);

    if(is_cowboy(killer))
    {
      new kills_n = get_pcvar_num(cvar_cowboy_upgrade_kills);
      new kills_h = get_pcvar_num(cvar_cowboy_upgrade_hskills);

      if(upgrade)
      {
        if(set_user_extrahealth(killer, get_pcvar_num(cvar_cowboy_upgrade_extrahp)))
        {  
          message_begin(MSG_ONE_UNRELIABLE, g_pMsgScreenFade, _, killer);
          write_short(1<<10);
          write_short(1<<10);
          write_short(0x0000);
          write_byte(200);
          write_byte(0);
          write_byte(0);
          write_byte(75);
          message_end();
        }
      }
      else if(get_pdata_int(victim, m_LastHitGroup) == HIT_HEAD)
      {
        g_iKillCount[killer][1]++;
        if(g_iKillCount[killer][1] >= kills_h)
          cvi_set_playerdata(killer, PD_UPGRADE, upgrade = true);
      }
      else
      {
        g_iKillCount[killer][0]++;
        if(g_iKillCount[killer][0] >= kills_n)
          cvi_set_playerdata(killer, PD_UPGRADE, upgrade = true);
      }

      if(!upgrade)
        client_print_color(killer, print_team_default, "%s %L", CVI_TAG, killer, "CVI_STILLNEED", kills_h - g_iKillCount[killer][1], kills_n - g_iKillCount[killer][0]);
    }
  }
  else if(is_user_connected(killer) && is_cowboy(killer))
  {
    g_iKillCount[killer][0] = 0;
    g_iKillCount[killer][1] = 0;
  }

  g_iKillCount[victim][0] = 0;
  g_iKillCount[victim][1] = 0;
}

public cvi_upgrade_class(id, player_class, val)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  if(val && is_user_alive(id) && player_class == PC_COWBOY)
  {
    set_user_extrahealth(id, get_pcvar_num(cvar_cowboy_upgrade_health));
    cs_set_user_armor(id, get_pcvar_num(cvar_cowboy_upgrade_armor), CS_ARMOR_VESTHELM);
    give_appearance(id);
    ham_give_weapon(id, "weapon_hegrenade");
  }
}

stock give_appearance(id)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  new r = random_num(1, 255), g = random_num(1, 255), b = random_num(1, 255);
  set_player_glow(id, 1, r, g, b, 30);

  static origin[3];
  get_user_origin(id, origin);
  message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
  write_byte(TE_BEAMCYLINDER);
  write_coord(origin[0]);
  write_coord(origin[1]);
  write_coord(origin[2]);
  write_coord(origin[0]);
  write_coord(origin[1]);
  write_coord(origin[2]+100);
  write_short(g_pSprite);
  write_byte(0);
  write_byte(0);
  write_byte(10);
  write_byte(4);
  write_byte(0);
  write_byte(r); // R
  write_byte(g); // G
  write_byte(b); // B
  write_byte(255); // brightness
  write_byte(0);
  message_end();
  emit_sound(id, CHAN_AUTO, g_szSound, 1.0, ATTN_NORM, 0, PITCH_NORM);
}

stock set_user_extrahealth(id, extra_hp)
{
  new current_hp = get_user_health(id);
  if(current_hp <= 100+extra_hp)
  {
    new new_hp = current_hp+extra_hp;
    if(new_hp > 100+extra_hp)
      new_hp = 100+extra_hp;

    set_user_health(id, new_hp);
    return 1;
  }

  return 0;
}
