#include <amxmodx>
#include <cstrike>
#include <fakemeta>
#include <engine>
#include <hamsandwich>
#include <fun>
#include <cvi>
#include <amx_settings_api>

#define PLAYER_OFFSET   5
#define m_flPainShock 108

new cvar_indian_normal_speed, cvar_indian_normal_gravity, cvar_indian_upgrade_speed, cvar_indian_upgrade_gravity;
new g_pSprite;
new g_szSound[CVI_MAXFILELENGHT];

public plugin_precache()
{
  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Upgrade Sounds", "INDIAN", g_szSound, charsmax(g_szSound)))
  {
    g_szSound = "cvi/indian.wav";
    amx_save_setting_string(CVI_SETTINGSFILE, "Upgrade Sounds", "INDIAN", g_szSound);
  }
  precache_sound(g_szSound);
  g_pSprite = precache_model("sprites/laserbeam.spr");
}

public plugin_init()
{
  register_plugin("[CVI] Class: Indian", CVI_VERSION, CVI_AUTHOR);

  cvar_indian_normal_speed    = my_register_cvar("cvi_indian_normal_speed", "310.0", "Normal indian movement speed. (Default: 310.0)");
  cvar_indian_normal_gravity  = my_register_cvar("cvi_indian_normal_gravity", "0.8", "Normal indian gravity. (Default: 0.8)");
  cvar_indian_upgrade_speed   = my_register_cvar("cvi_indian_upgrade_speed", "330.0", "Upgraded indian movement speed. (Default: 330.0)");
  cvar_indian_upgrade_gravity = my_register_cvar("cvi_indian_upgrade_gravity", "0.65", "Upgraded indian gravity. (Default: 0.65)");

  register_event("DeathMsg", "Event_DeathMsg", "a", "4=knife");
  RegisterHamPlayer(Ham_TakeDamage, "Ham_TakeDamage_post", 1);
  RegisterHamPlayer(Ham_CS_Player_ResetMaxSpeed, "Ham_Player_ResetMaxSpeed_post", 1);
}

public client_PreThink(id)
{
  if(!is_user_alive(id) || !is_indian(id) || cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  if(pev(id, pev_fuser2) && is_upgraded(id))
    set_pev(id, pev_fuser2, 0.0);
}

public Event_DeathMsg()
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  new killer = read_data(1);
  if(is_user_alive(killer) && is_user_connected(read_data(2)) && is_indian(killer) && !is_upgraded(killer))
  {
    cvi_set_playerdata(killer, PD_UPGRADE, true);
    if(get_user_weapon(killer) == CSW_KNIFE)
    {
      new ent = find_ent_by_owner(-1, "weapon_knife", killer);
      ExecuteHamB(Ham_Item_Deploy, ent);
    }
  }
}

public Ham_TakeDamage_post(victim, inflictor, attacker, Float:damage, damage_type)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  if(is_user_alive(victim) && is_indian(victim))
    set_pdata_float(victim, m_flPainShock, 1.0, PLAYER_OFFSET);
}

public Ham_Player_ResetMaxSpeed_post(id)
{
  if(!is_user_alive(id) || !is_indian(id))
    return;

  if(is_upgraded(id))
    cs_reset_user_maxspeed(id, get_pcvar_float(cvar_indian_upgrade_speed));
  else cs_reset_user_maxspeed(id, get_pcvar_float(cvar_indian_normal_speed));
}

public cvi_gamemode(mode)
{
  if(mode == GAME_STARTED)
  {
    new num, id, Float:cvars[2];
    cvars[0] = get_pcvar_float(cvar_indian_normal_speed);
    cvars[1] = get_pcvar_float(cvar_indian_normal_gravity);
    static players[32];
    get_players(players, num);

    for(--num; num >= 0; num--)
    {
      id = players[num];
      if(is_user_alive(id) && is_indian(id))
      {
        client_print_color(id, print_team_default, "%s %L", CVI_TAG, id, "CVI_NEEDTO_I");
        cs_reset_user_maxspeed(id, cvars[0]);
        set_user_gravity(id, cvars[1]);
        ham_give_weapon(id, "weapon_knife");
        set_user_footsteps(id, 0);
        cvi_set_playerdata(id, PD_ITEMCOUNT, 1);
      }
    }
  }
}

public cvi_upgrade_class(id, player_class, val)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  if(val && is_user_alive(id) && player_class == PC_INDIAN)
  {
    cs_reset_user_maxspeed(id, get_pcvar_float(cvar_indian_upgrade_speed));
    set_user_gravity(id, get_pcvar_float(cvar_indian_upgrade_gravity));
    set_user_footsteps(id, 1);
    give_appearance(id);
    cvi_set_playerdata(id, PD_ITEMCOUNT, cvi_get_playerdata(id, PD_ITEMCOUNT)+1);
  }
}

stock give_appearance(id)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  new r = random_num(1, 255), g = random_num(1, 255), b = random_num(1, 255);
  set_player_glow(id, 1, r, g, b, 30);

  static origin[3];
  get_user_origin(id, origin);
  message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
  write_byte(TE_BEAMCYLINDER);
  write_coord(origin[0]);
  write_coord(origin[1]);
  write_coord(origin[2]);
  write_coord(origin[0]);
  write_coord(origin[1]);
  write_coord(origin[2]+100);
  write_short(g_pSprite);
  write_byte(0);
  write_byte(0);
  write_byte(10);
  write_byte(4);
  write_byte(0);
  write_byte(r); // R
  write_byte(g); // G
  write_byte(b); // B
  write_byte(255); // brightness
  write_byte(0);
  message_end();
  emit_sound(id, CHAN_AUTO, g_szSound, 1.0, ATTN_NORM, 0, PITCH_NORM);
}
