#include <amxmodx>
#include <engine>
#include <cvi>

new g_iStatusSync, g_iHPAPSync;
new const g_szClassNames[][] =
{
  "CVI_NONE",
  "CVI_COWBOY",
  "CVI_INDIAN",
  "CVI_COWBOY_U",
  "CVI_INDIAN_U"
};

public plugin_init()
{
  register_plugin("[CVI] Special player info", CVI_VERSION, CVI_AUTHOR);

  register_event("StatusValue", "Event_StatusValue_S", "be", "1=2", "2!0");
  register_event("StatusValue", "Event_StatusValue_H", "be", "1=1", "2=0");

  g_iStatusSync = CreateHudSyncObj();
  g_iHPAPSync   = CreateHudSyncObj();
}

public client_putinserver(id)
{
  set_task(1.0, "show_status", id, _, _, "b");
}

public client_disconnect(id)
{
  if(task_exists(id))
    remove_task(id);
}

public Event_StatusValue_S(id)
{
  if(!is_user_connected(id) || cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  new pid = read_data(2);
  static name[32];
  get_user_name(pid, name, charsmax(name));

  set_hudmessage(255, 50, 0, -1.0, 0.60, 1, 0.01, 3.0, 0.01, 0.01, -1);
  ShowSyncHudMsg(id, g_iStatusSync, "%s -- [HP = %d]", name, get_user_health(pid));
}

public Event_StatusValue_H(id)
{
  ClearSyncHud(id, g_iStatusSync);
}

public show_status(alive)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  new dead = alive;
  if(!is_user_alive(dead))
  {
    alive = entity_get_int(dead, EV_INT_iuser2);
    if(!is_user_alive(alive))
      return;
  }

  new upgrade;
  if(is_upgraded(alive))
    upgrade = 2;

  set_hudmessage(255, 0, 50, 0.02, 0.89, 0, 6.0, 1.1, 0.0, 0.0, -1);
  ShowSyncHudMsg(is_user_alive(dead) ? alive : dead, g_iHPAPSync, "[%L] --- [HP %d] --- [AP %d]", is_user_alive(dead) ? alive : dead,
  g_szClassNames[upgrade+cvi_get_playerdata(alive, PD_CLASS)], get_user_health(alive), get_user_armor(alive));
}
