#include <amxmodx>
#include <engine>
#include <cvi>

enum _:CVI_TEAMS
{
  CVI_T = 0,
  CVI_CT
}

new const g_szSpawnClassNames[][] =
{
  "info_player_start",
  "info_player_deathmatch"
};

new g_iNum[CVI_TEAMS], g_iEnt[CVI_TEAMS][32];
new Float:g_fOrigin[CVI_TEAMS][32][3];
new Float:g_fAngles[CVI_TEAMS][32][3];
new cvar_swap_every, g_iMinCount;

public plugin_init()
{
  register_plugin("[CVI] Team spawn swapper", CVI_VERSION, CVI_AUTHOR);
  cvar_swap_every = my_register_cvar("cvi_swap_every", "1", "Spawn every X round. 0 - off (Default: 1)");

  for(new ent, i = 0; i < 2; i++)
  {
    ent = -1;
    while((ent = find_ent_by_class(ent, g_szSpawnClassNames[i])) != 0)
    {
      g_iEnt[i][g_iNum[i]] = ent;
      entity_get_vector(ent, EV_VEC_origin, g_fOrigin[i][g_iNum[i]]);
      entity_get_vector(ent, EV_VEC_angles, g_fAngles[i][g_iNum[i]]);
      g_iNum[i]++;
      if(g_iNum[i] > 31)
        break;
    }
  }

  g_iMinCount = min(g_iNum[CVI_T], g_iNum[CVI_CT]);
  if(!g_iNum[CVI_T] || !g_iNum[CVI_CT])
  {
    new map[32], msg[96];
    get_mapname(map, charsmax(map));
    formatex(msg, charsmax(msg), "WARNING: This map (^"%s^") doesn't have spawn points for one team, plugin disabled on this map!", map);
    set_fail_state(msg);
    return;
  }
}

public cvi_gamemode(mode)
{
  if(mode == GAME_ENDED)
  {
    new every = get_pcvar_num(cvar_swap_every);
    if(!every)
      return;

    if(my_modulus(cvi_get_globalinfo(GI_ROUNDCOUNT), every))
      return;

    new num;
    static players[32];
    get_players(players, num);

    if(!num)
      return;

    new Float:vector[3];
    for(new i = 0; i < g_iMinCount; i++)
    {
      vector = g_fOrigin[CVI_T][i];
      g_fOrigin[CVI_T][i] = g_fOrigin[CVI_CT][i];
      g_fOrigin[CVI_CT][i] = vector;

      vector = g_fAngles[CVI_T][i];
      g_fAngles[CVI_T][i] = g_fAngles[CVI_CT][i];
      g_fAngles[CVI_CT][i] = vector;

      entity_set_origin(g_iEnt[CVI_T][i], g_fOrigin[CVI_T][i]);
      entity_set_vector(g_iEnt[CVI_T][i], EV_VEC_angles, g_fAngles[CVI_T][i]);
      entity_set_origin(g_iEnt[CVI_CT][i], g_fOrigin[CVI_CT][i]);
      entity_set_vector(g_iEnt[CVI_CT][i], EV_VEC_angles, g_fAngles[CVI_CT][i]);
    }
  }
}

stock my_modulus(arg1, arg2)
{
  new result = arg1/arg2;
  return arg1 - result*arg2;
}
