#include <amxmodx>
#include <engine>
#include <cs_weapons_api>
#include <amx_settings_api>
#include <cvi>

#define WEAPON_CSWID CSW_M3
#define WEAPON_NAME "weapon_m3"

new g_szModels[3][CVI_MAXFILELENGHT];
new cvar_weapon_damage, cvar_weapon_speed, cvar_weapon_ammo, cvar_weapon_clip, cvar_weapon_reload, cvar_weapon_recoil;

public plugin_precache()
{
  precache_sound("weapons/m1887_draw.wav");
  precache_sound("weapons/m1887_insert.wav");
  precache_sound("weapons/m1887_reafter.wav");
  precache_sound("weapons/m1887_restart.wav");

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Winchester 1887m", "MODEL_V", g_szModels[0], charsmax(g_szModels[])))
  {
    g_szModels[0] = "models/cvi/v_1887m.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Winchester 1887m", "MODEL_V", g_szModels[0]);
  }
  precache_model(g_szModels[0]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Winchester 1887m", "MODEL_P", g_szModels[1], charsmax(g_szModels[])))
  {
    g_szModels[1] = "models/cvi/p_1887m.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Winchester 1887m", "MODEL_P", g_szModels[1]);
  }
  precache_model(g_szModels[1]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Winchester 1887m", "MODEL_W", g_szModels[2], charsmax(g_szModels[])))
  {
    g_szModels[2] = "models/cvi/w_1887m.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Winchester 1887m", "MODEL_W", g_szModels[2]);
  }
  precache_model(g_szModels[2]);

}

public plugin_init()
{
  register_plugin("[CVI] Weapon: Winchester 1887m", CVI_VERSION, CVI_AUTHOR);

  cvar_weapon_clip   = my_register_cvar("cvi_1887m_clip", "4", "Amount of bullets in clip. (Default: 4)");
  cvar_weapon_ammo   = my_register_cvar("cvi_1887m_ammo", "32", "Amount of bullets in backpack. (Default: 32)");
  cvar_weapon_speed  = my_register_cvar("cvi_1887m_speed", "0.8", "Attack speed multiplier. (Default: 0.8)");
  cvar_weapon_damage = my_register_cvar("cvi_1887m_damage", "1.15", "Damage multiplier. (Default: 1.15)");
  cvar_weapon_reload = my_register_cvar("cvi_1887m_reload", "0.0", "Additional reload time. (Default: 0.0)");
  cvar_weapon_recoil = my_register_cvar("cvi_1887m_recoil", "0.0", "Additional recoil time. (Default: 0.0)");
}

public cvi_gamemode(mode)
{
  if(mode == GAME_STARTED)
  {
    new num, id;
    static players[32];
    get_players(players, num);

    for(--num; num >= 0; num--)
    {
      id = players[num];
      if(is_user_alive(id) && is_cowboy(id))
        give_weap(id);
    }
  }
}

public give_weap(id)
{
  if(user_has_weapon(id, WEAPON_CSWID))
    engclient_cmd(id, "drop", WEAPON_NAME);

  static data[STOREABLE_STRUCTURE];
  if(!data[STRUCT_CSWA_CSW])
  {
    data[STRUCT_CSWA_CSW] = WEAPON_CSWID;
    data[STRUCT_CSWA_CLIP] = get_pcvar_num(cvar_weapon_clip);
    data[STRUCT_CSWA_MAXCLIP] = get_pcvar_num(cvar_weapon_clip);
    data[STRUCT_CSWA_AMMO] = get_pcvar_num(cvar_weapon_ammo);
    data[STRUCT_CSWA_STACKABLE] = false;
    data[STRUCT_CSWA_SILENCED] = -1;
    data[STRUCT_CSWA_SPEEDDELAY] = _:get_pcvar_float(cvar_weapon_speed);
    data[STRUCT_CSWA_DAMAGE] = _:get_pcvar_float(cvar_weapon_damage);
    data[STRUCT_CSWA_RELOADTIME] = _:get_pcvar_float(cvar_weapon_reload);
    data[STRUCT_CSWA_RECOIL] = _:get_pcvar_float(cvar_weapon_recoil);
    data[STRUCT_CSWA_MODEL_V] = g_szModels[0];
    data[STRUCT_CSWA_MODEL_P] = g_szModels[1];
    data[STRUCT_CSWA_MODEL_W] = g_szModels[2];
  }

  cswa_give_specific(id, data, true);
}
