#include <amxmodx>
#include <engine>
#include <cstrike>
#include <fakemeta>
#include <hamsandwich>
#include <cs_weapons_api>
#include <amx_settings_api>
#include <cvi>

#define OFFSET_LINUX_WEAPONS     4
#define OFFSET_LINUX_PLAYERS     5
#define m_flNextSecondaryAttack 47
#define m_flTimeWeaponIdle      48

#define WEAPON_CSWID CSW_SCOUT
#define WEAPON_NAME "weapon_scout"

new g_szModels[3][CVI_MAXFILELENGHT];
new cvar_weapon_damage, cvar_weapon_speed, cvar_weapon_ammo, cvar_weapon_clip, cvar_weapon_reload, cvar_weapon_recoil;
new g_pMsgWeaponList;

public plugin_precache()
{
  precache_sound("weapons/natianul.wav");
  precache_generic("sprites/weapon_bow.txt");
  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Bow", "MODEL_V", g_szModels[0], charsmax(g_szModels[])))
  {
    g_szModels[0] = "models/cvi/v_bow.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Bow", "MODEL_V", g_szModels[0]);
  }
  precache_model(g_szModels[0]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Bow", "MODEL_P", g_szModels[1], charsmax(g_szModels[])))
  {
    g_szModels[1] = "models/cvi/p_bow.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Bow", "MODEL_P", g_szModels[1]);
  }
  precache_model(g_szModels[1]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Bow", "MODEL_W", g_szModels[2], charsmax(g_szModels[])))
  {
    g_szModels[2] = "models/cvi/w_bow.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Bow", "MODEL_W", g_szModels[2]);
  }
  precache_model(g_szModels[2]);

}

public plugin_init()
{
  register_plugin("[CVI] Weapon: Bow", CVI_VERSION, CVI_AUTHOR);

  cvar_weapon_clip    = my_register_cvar("cvi_bow_clip", "100", "Amount of bullets in clip. (Default: 100)");
  cvar_weapon_ammo    = my_register_cvar("cvi_bow_ammo", "0", "Amount of bullets in backpack. (Default: 0)");
  cvar_weapon_speed   = my_register_cvar("cvi_bow_speed", "1.5", "Attack speed multiplier. (Default: 1.5)");
  cvar_weapon_damage  = my_register_cvar("cvi_bow_damage", "1.75", "Damage multiplier. (Default: 1.75)");
  cvar_weapon_reload  = my_register_cvar("cvi_bow_reload", "0.0", "Additional reload time. (Default: 0.0)");
  cvar_weapon_recoil  = my_register_cvar("cvi_bow_recoil", "0.0", "Additional recoil time. (Default: 0.0)");

  RegisterHam(Ham_Weapon_SecondaryAttack, WEAPON_NAME, "Ham_SecondaryAttack_pre", 0);
  g_pMsgWeaponList = get_user_msgid("WeaponList");
  register_clcmd("weapon_bow", "weapon_hook");
}

public weapon_hook(id)
{
  engclient_cmd(id, WEAPON_NAME);
  return PLUGIN_HANDLED;
}

public cvi_gamemode(mode)
{
  if(mode == GAME_STARTED)
  {
    new num, id;
    static players[32];
    get_players(players, num);

    for(--num; num >= 0; num--)
    {
      id = players[num];
      if(is_user_alive(id) && is_indian(id))
        give_weap(id);
    }
  }
}

public give_weap(id)
{
  if(user_has_weapon(id, WEAPON_CSWID))
    engclient_cmd(id, "drop", WEAPON_NAME);

  static data[STOREABLE_STRUCTURE];
  if(!data[STRUCT_CSWA_CSW])
  {
    data[STRUCT_CSWA_CSW] = WEAPON_CSWID;
    data[STRUCT_CSWA_CLIP] = get_pcvar_num(cvar_weapon_clip);
    data[STRUCT_CSWA_MAXCLIP] = get_pcvar_num(cvar_weapon_clip);
    data[STRUCT_CSWA_AMMO] = get_pcvar_num(cvar_weapon_ammo);
    data[STRUCT_CSWA_STACKABLE] = false;
    data[STRUCT_CSWA_SILENCED] = -1;
    data[STRUCT_CSWA_SPEEDDELAY] = _:get_pcvar_float(cvar_weapon_speed);
    data[STRUCT_CSWA_DAMAGE] = _:get_pcvar_float(cvar_weapon_damage);
    data[STRUCT_CSWA_RELOADTIME] = _:get_pcvar_float(cvar_weapon_reload);
    data[STRUCT_CSWA_RECOIL] = _:get_pcvar_float(cvar_weapon_recoil);
    data[STRUCT_CSWA_MODEL_V] = g_szModels[0];
    data[STRUCT_CSWA_MODEL_P] = g_szModels[1];
    data[STRUCT_CSWA_MODEL_W] = g_szModels[2];
  }

  cswa_give_specific(id, data, true);
}

public Ham_SecondaryAttack_pre(ent)
{
  new id = pev(ent, pev_owner);
  if(!is_user_connected(id))
    return HAM_IGNORED;

  if(cs_get_user_zoom(id) == CS_SET_NO_ZOOM)
  {
    cs_set_user_zoom(id, CS_SET_AUGSG552_ZOOM, true);
    message_begin(MSG_ONE_UNRELIABLE, g_pMsgWeaponList, _, id);
    write_string("weapon_bow");
    write_byte(2);
    write_byte(get_pcvar_num(cvar_weapon_clip));
    write_byte(-1);
    write_byte(-1);
    write_byte(0);
    write_byte(9);
    write_byte(CSW_SCOUT);
    write_byte(0);
    message_end();
  }
  else cs_set_user_zoom(id, CS_RESET_ZOOM, true);

  set_pdata_float(ent, m_flNextSecondaryAttack, 0.3, OFFSET_LINUX_WEAPONS);
  set_pdata_float(ent, m_flTimeWeaponIdle, 0.3, OFFSET_LINUX_WEAPONS);
  return HAM_SUPERCEDE;
}
