#include <amxmodx>
#include <engine>
#include <cstrike>
#include <cs_weapons_api>
#include <amx_settings_api>
#include <cvi>

#define WEAPON_CSWID CSW_FIVESEVEN
#define WEAPON_NAME "weapon_fiveseven"

new g_szModels[3][CVI_MAXFILELENGHT];
new cvar_weapon_damage, cvar_weapon_speed, cvar_weapon_ammo, cvar_weapon_clip, cvar_weapon_reload, cvar_weapon_recoil;

public plugin_precache()
{
  precache_sound("weapons/contender_close.wav");
  precache_sound("weapons/contender_hammerback.wav");
  precache_sound("weapons/contender_insert.wav");
  precache_sound("weapons/contender_open.wav");
  precache_sound("weapons/contender_shell.wav");
  precache_sound("weapons/contender_shellout.wav");

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Contender", "MODEL_V", g_szModels[0], charsmax(g_szModels[])))
  {
    g_szModels[0] = "models/cvi/v_contender.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Contender", "MODEL_V", g_szModels[0]);
  }
  precache_model(g_szModels[0]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Contender", "MODEL_P", g_szModels[1], charsmax(g_szModels[])))
  {
    g_szModels[1] = "models/cvi/p_contender.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Contender", "MODEL_P", g_szModels[1]);
  }
  precache_model(g_szModels[1]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Contender", "MODEL_W", g_szModels[2], charsmax(g_szModels[])))
  {
    g_szModels[2] = "models/cvi/w_contender.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Contender", "MODEL_W", g_szModels[2]);
  }
  precache_model(g_szModels[2]);

}

public plugin_init()
{
  register_plugin("[CVI] Weapon: Contender", CVI_VERSION, CVI_AUTHOR);

  cvar_weapon_clip   = my_register_cvar("cvi_contender_clip", "1", "Amount of bullets in clip. (Default: 1)");
  cvar_weapon_ammo   = my_register_cvar("cvi_contender_ammo", "25", "Amount of bullets in backpack. (Default: 25)");
  cvar_weapon_speed  = my_register_cvar("cvi_contender_speed", "0.5", "Attack speed multiplier. (Default: 0.5)");
  cvar_weapon_damage = my_register_cvar("cvi_contender_damage", "2.3", "Damage multiplier. (Default: 2.3)");
  cvar_weapon_reload = my_register_cvar("cvi_contender_reload", "1.7", "Additional reload time. (Default: 1.7)");
  cvar_weapon_recoil = my_register_cvar("cvi_contender_recoil", "0.0", "Additional recoil time. (Default: 0.0)");
}

public cvi_upgrade_class(id, player_class, val)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  if(val && is_user_alive(id) && player_class == PC_INDIAN)
  {
    new ent = find_ent_by_owner(-1, WEAPON_NAME, id);
    if(is_valid_ent(ent))
    {
      set_weapon_string(ent, REPL_CSWA_MODEL_V, g_szModels[0]);
      set_weapon_string(ent, REPL_CSWA_MODEL_P, g_szModels[1]);
      set_weapon_string(ent, REPL_CSWA_MODEL_W, g_szModels[2]);

      set_weapon_float(ent, REPL_CSWA_SPEEDDELAY, get_pcvar_float(cvar_weapon_speed));
      set_weapon_float(ent, REPL_CSWA_DAMAGE, get_pcvar_float(cvar_weapon_damage));

      new clip = get_weapon_integer(ent, REPL_CSWA_CLIP)+get_pcvar_num(cvar_weapon_clip);
      cs_set_weapon_ammo(ent, clip);
      set_weapon_integer(ent, REPL_CSWA_CLIP, clip);
      set_weapon_integer(ent, REPL_CSWA_MAXCLIP, get_weapon_integer(ent, REPL_CSWA_MAXCLIP)*2);
      set_weapon_integer(ent, REPL_CSWA_AMMO, get_weapon_integer(ent, REPL_CSWA_AMMO)+get_pcvar_num(cvar_weapon_ammo));
      //show_weapon(id, WEAPON_NAME);
    }
    else
    {
      static data[STOREABLE_STRUCTURE];
      if(!data[STRUCT_CSWA_CSW])
      {
        data[STRUCT_CSWA_CSW] = WEAPON_CSWID;
        data[STRUCT_CSWA_CLIP] = get_pcvar_num(cvar_weapon_clip)*2;
        data[STRUCT_CSWA_MAXCLIP] = get_pcvar_num(cvar_weapon_clip)*2;
        data[STRUCT_CSWA_AMMO] = get_pcvar_num(cvar_weapon_ammo)*2;
        data[STRUCT_CSWA_STACKABLE] = false;
        data[STRUCT_CSWA_SILENCED] = -1;
        data[STRUCT_CSWA_SPEEDDELAY] = _:get_pcvar_float(cvar_weapon_speed);
        data[STRUCT_CSWA_DAMAGE] = _:get_pcvar_float(cvar_weapon_damage);
        data[STRUCT_CSWA_RELOADTIME] = _:get_pcvar_float(cvar_weapon_reload);
        data[STRUCT_CSWA_RECOIL] = _:get_pcvar_float(cvar_weapon_recoil);
        data[STRUCT_CSWA_MODEL_V] = g_szModels[0];
        data[STRUCT_CSWA_MODEL_P] = g_szModels[1];
        data[STRUCT_CSWA_MODEL_W] = g_szModels[2];
      }

      cswa_give_specific(id, data);
    }
  }
}

public cvi_gamemode(mode)
{
  if(mode == GAME_STARTED)
  {
    new num, id;
    static players[32];
    get_players(players, num);

    for(--num; num >= 0; num--)
    {
      id = players[num];
      if(is_user_alive(id) && is_indian(id))
        give_weap(id);
    }
  }
}

public give_weap(id)
{
  if(user_has_weapon(id, WEAPON_CSWID))
    engclient_cmd(id, "drop", WEAPON_NAME);

  static data[STOREABLE_STRUCTURE];
  if(!data[STRUCT_CSWA_CSW])
  {
    data[STRUCT_CSWA_CSW] = WEAPON_CSWID;
    data[STRUCT_CSWA_CLIP] = get_pcvar_num(cvar_weapon_clip);
    data[STRUCT_CSWA_MAXCLIP] = get_pcvar_num(cvar_weapon_clip);
    data[STRUCT_CSWA_AMMO] = get_pcvar_num(cvar_weapon_ammo);
    data[STRUCT_CSWA_STACKABLE] = false;
    data[STRUCT_CSWA_SILENCED] = -1;
    data[STRUCT_CSWA_SPEEDDELAY] = _:get_pcvar_float(cvar_weapon_speed);
    data[STRUCT_CSWA_DAMAGE] = _:get_pcvar_float(cvar_weapon_damage);
    data[STRUCT_CSWA_RELOADTIME] = _:get_pcvar_float(cvar_weapon_reload);
    data[STRUCT_CSWA_RECOIL] = _:get_pcvar_float(cvar_weapon_recoil);
    data[STRUCT_CSWA_MODEL_V] = g_szModels[0];
    data[STRUCT_CSWA_MODEL_P] = g_szModels[1];
    data[STRUCT_CSWA_MODEL_W] = g_szModels[2];
  }

  cswa_give_specific(id, data);
}
