#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <engine>
#include <cstrike>
#include <cvi>
#include <amx_settings_api>

#define XO_WEAPON                4
#define m_pPlayer               41
#define m_flNextPrimaryAttack   46
#define m_flNextSecondaryAttack 47
#define m_flTimeWeaponIdle      48

new g_szKnifeModels[CVI_MAXFILELENGHT];
new const Float:g_szDroppedSize[][3] =
{
  {-20.0, -20.0, -5.0},
  {20.0, 20.0, 5.0}
};

new g_iNadeVelocity[33][2];
new cvar_dmgmult, cvar_pattack_rate, cvar_sattack_rate, cvar_pattack_recoil,
  cvar_sattack_recoil, cvar_knife_glow, cvar_knife_velocity, cvar_knife_bounce, cvar_cowboy_dmgmult;
new g_pMsgDeathMsg;

public plugin_precache()
{
  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Indian", "KNIFE_MODEL_W", g_szKnifeModels, charsmax(g_szKnifeModels)))
  {
    g_szKnifeModels = "models/cvi/w_axe_indian.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Indian", "KNIFE_MODEL_W", g_szKnifeModels);
  }
  precache_model(g_szKnifeModels);
}

public plugin_init()
{
  register_plugin("[CVI] Weapon: Knife", CVI_VERSION, CVI_AUTHOR);

  cvar_dmgmult        = my_register_cvar("cvi_knife_multi", "11.0", "Damage multiplier. (Default: 11.0)");
  cvar_pattack_rate   = my_register_cvar("cvi_knife_primary_rate", "0.6", "Primary attack speed. (Default: 0.6)");
  cvar_sattack_rate   = my_register_cvar("cvi_knife_secondary_rate", "1.3", "Secondary attack speed. (Default: 1.3)");
  cvar_pattack_recoil = my_register_cvar("cvi_knife_primary_recoil", "-3.6", "Primary recoil. (Default: -3.6)");
  cvar_sattack_recoil = my_register_cvar("cvi_knife_secondary_recoil", "-5.0", "Secondary recoil. (Default: -5.0)");
  cvar_knife_glow     = my_register_cvar("cvi_knife_glow", "1", "Should thrown knife glow? 0/1 off/on (Default: 1)");
  cvar_knife_velocity = my_register_cvar("cvi_knife_velocity", "1000", "Thrown speed. (Default: 1000)");
  cvar_knife_bounce   = my_register_cvar("cvi_knife_bounce", "0", "Should knife bounce off walls? 0/1 off/on. (Default: 0)");
  cvar_cowboy_dmgmult = my_register_cvar("cvi_cowboy_dmgmult", "1.5", "Cowboy knife damage multiplier. (Default: 1.5)");

  register_think("grenade", "Think_Grenade");
  register_touch("grenade", "*", "Touch_Grenade");

  RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_smokegrenade", "Ham_PrimaryAttack_Grenade_pre", 0);
  RegisterHamPlayer(Ham_TakeDamage, "Ham_TakeDamage_pre", 0);
  RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_knife", "Ham_PrimaryAttack_post", 1);
  RegisterHam(Ham_Weapon_SecondaryAttack, "weapon_knife", "Ham_SecondaryAttack_post", 1);

  register_clcmd("drop", "clcmd_drop");
  g_pMsgDeathMsg = get_user_msgid("DeathMsg");
}

public client_disconnect(id)
{
  g_iNadeVelocity[id][0] = false;
  g_iNadeVelocity[id][1] = false;
}

public cvi_gamemode(mode)
{
  if(mode == GAME_STARTED || mode == GAME_RESTARTING)
  {
    // move_grenade();
    new num, id;
    static players[32];
    get_players(players, num);
    for(--num; num >= 0; num--)
    {
      id = players[num];
      g_iNadeVelocity[id][0] = false;
      g_iNadeVelocity[id][1] = false;
    }
  }
}

public clcmd_drop(id)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return PLUGIN_CONTINUE;

  if(get_user_weapon(id) == CSW_KNIFE)
  {
    clcmd_throw(id, 64, 1);
    return PLUGIN_HANDLED;
  }

  return PLUGIN_CONTINUE;
}

public clcmd_throw(id, vel, value)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  if(is_indian(id))
  {
    new ent;
    if(!user_has_weapon(id, CSW_SMOKEGRENADE))
      ent = ham_give_weapon(id, "weapon_smokegrenade", 1);
    else ent = fm_find_ent_by_owner(-1, "weapon_smokegrenade", id);

    new count = cvi_get_playerdata(id, PD_ITEMCOUNT) -1;
    cvi_set_playerdata(id, PD_ITEMCOUNT, count);
    g_iNadeVelocity[id][0] = vel;
    g_iNadeVelocity[id][1] = value;
    ExecuteHamB(Ham_Weapon_PrimaryAttack, ent);
    set_pdata_float(ent, m_flTimeWeaponIdle, 0.0, XO_WEAPON);
    ExecuteHam(Ham_Weapon_WeaponIdle, ent);
    if(!count)
    {
      ham_strip_weapon(id, "weapon_knife");
      show_weapon(id, "weapon_scout");
    }
    else show_knife(id);
  }
}

public grenade_throw(id, ent, nade)
{
  if(nade == CSW_SMOKEGRENADE && is_user_alive(id) && is_indian(id))
  {
    static Float:velocity[3];
    VelocityByAim(id, g_iNadeVelocity[id][0], velocity);
    if(g_iNadeVelocity[id][1])
    {
      static Float:origin[3];
      entity_get_vector(id, EV_VEC_origin, origin);
      origin[0] += velocity[0];
      origin[1] += velocity[1];
      entity_set_origin(ent, origin);
    }

    entity_set_vector(ent, EV_VEC_velocity, velocity);
    entity_set_int(ent, EV_INT_iuser4, id);
    entity_set_float(ent, EV_FL_nextthink, get_gametime()+0.01);
    if(get_pcvar_num(cvar_knife_glow))
      UTIL_SetRendering(ent, kRenderFxGlowShell, Float:{255.0, 0.0, 0.0}, _, 50.0);

    if(entity_get_float(ent, EV_FL_dmgtime) != 0.0)
      entity_set_model(ent, g_szKnifeModels);
  }
}

public Think_Grenade(ent)
{
  if(!is_valid_ent(ent) || GetGrenadeType(ent) != CSW_SMOKEGRENADE || cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  new owner = entity_get_int(ent, EV_INT_iuser4);
  if(!owner)
    return;

  static Float:velocity[3], Float:angles[3];
  entity_get_vector(ent, EV_VEC_velocity, velocity);

  if(entity_get_int(ent, EV_INT_flags) & FL_ONGROUND)
  {
    static Float:origin[3];
    entity_set_vector(ent, EV_VEC_velocity, Float:{0.0, 0.0, 0.0});
    entity_set_size(ent, g_szDroppedSize[0], g_szDroppedSize[1]);
    entity_get_vector(ent, EV_VEC_angles, angles);
    // entity_set_int(ent, EV_INT_solid, SOLID_TRIGGER);

    angles[0] = 270.0;
    entity_set_vector(ent, EV_VEC_angles, angles);
    entity_get_vector(ent, EV_VEC_origin, origin);
    if(engfunc(EngFunc_PointContents, origin) == CONTENTS_SKY)
      give_knife(owner, ent);
  }
  else
  {
    static rotate[33];
    if(!rotate[owner])
      rotate[owner] = 1;

    vector_to_angle(velocity, angles);
    angles[0] = 180.0;
    angles[1] += -90.0;
    angles[2] += rotate[owner]*15.0;
    entity_set_vector(ent, EV_VEC_angles, angles);

    rotate[owner]++;
    if(rotate[owner] > 24)
      rotate[owner] = 1;
  }

  if(is_valid_ent(ent))
    entity_set_float(ent, EV_FL_dmgtime, get_gametime() + 999999.0);
}

public Touch_Grenade(nade, id)
{
  if(!is_valid_ent(nade) || GetGrenadeType(nade) != CSW_SMOKEGRENADE || !entity_get_int(nade, EV_INT_iuser4) || cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return PLUGIN_CONTINUE;

  if(is_user_alive(id))
  {
    new owner = entity_get_edict(nade, EV_ENT_owner);
    if(!owner)
    {
      if(is_indian(id))
        return give_knife(id, nade);
    }
    else
    {
      if(owner == id)
        return PLUGIN_CONTINUE;

      if(!is_indian(id))
      {
        new msgblock = get_msg_block(g_pMsgDeathMsg);
        set_msg_block(g_pMsgDeathMsg, BLOCK_ONCE);
        ExecuteHam(Ham_TakeDamage, id, owner, owner, 500.0, DMG_SLASH);
        set_msg_block(g_pMsgDeathMsg, msgblock);
        make_deathmsg(owner, id, 0, "knife");
        if(!is_upgraded(owner))
          cvi_set_playerdata(owner, PD_UPGRADE, true);
      }

      emit_sound(id, CHAN_AUTO, "weapons/knife_hit4.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);
      entity_set_vector(nade, EV_VEC_velocity, Float:{0.0, 0.0, 0.0});
      entity_set_edict(nade, EV_ENT_owner, 0);
      drop_to_floor(nade);

      return PLUGIN_HANDLED;
    }
  }
  else
  {
    entity_set_edict(nade, EV_ENT_owner, 0);
    if(get_pcvar_num(cvar_knife_bounce))
    {
      static Float:velocity[3];
      entity_get_vector(nade, EV_VEC_velocity, velocity);
      if(velocity[2] > 0.0)
      {
        velocity[2] = -(velocity[2]/2.0);
        entity_set_vector(nade, EV_VEC_velocity, velocity);
      }

      return PLUGIN_HANDLED;
    }
    else
    {
      entity_set_vector(nade, EV_VEC_velocity, Float:{0.0, 0.0, 0.0});
      emit_sound(nade, CHAN_AUTO, "weapons/knife_hit4.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);
      return PLUGIN_HANDLED;
    }
  }

  return PLUGIN_CONTINUE;
}

public Ham_PrimaryAttack_post(knife)
{
  if(!is_valid_ent(knife))
    return;
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  new id = get_pdata_cbase(knife, m_pPlayer, XO_WEAPON);
  if(is_user_connected(id) && get_user_weapon(id) == CSW_KNIFE && is_indian(id))
  {
    attack_post(id, knife, get_pcvar_float(cvar_pattack_rate), get_pcvar_float(cvar_pattack_recoil));
    clcmd_throw(id, get_pcvar_num(cvar_knife_velocity), 0);
  }
}

public Ham_SecondaryAttack_post(knife)
{  
  if(!is_valid_ent(knife))
    return;

  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  new id = get_pdata_cbase(knife, m_pPlayer, XO_WEAPON);
  if(is_user_connected(id) && get_user_weapon(id) == CSW_KNIFE && is_indian(id))
    attack_post(id, knife, get_pcvar_float(cvar_sattack_rate), get_pcvar_float(cvar_sattack_recoil));
}

public Ham_PrimaryAttack_Grenade_pre(nade)
{
  if(!is_valid_ent(nade))
    return;

  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  if(is_user_alive(get_pdata_cbase(nade, m_pPlayer, XO_WEAPON)))
  {
    set_pdata_float(nade, m_flTimeWeaponIdle, 0.0, XO_WEAPON);
    ExecuteHam(Ham_Weapon_WeaponIdle, nade);
  }
}

public Ham_TakeDamage_pre(victim, inflictor, attacker, Float:damage, damage_bits)
{  
  if(victim == attacker || !is_user_connected(attacker) || !is_user_alive(inflictor) || cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return HAM_IGNORED;

  if(inflictor == attacker && get_user_weapon(attacker) == CSW_KNIFE && cs_get_user_team(victim) != cs_get_user_team(attacker))
  {
    //a_lot_of_blood(victim);
    if(is_indian(attacker))
      SetHamParamFloat(4, damage * get_pcvar_float(cvar_dmgmult));
    else SetHamParamFloat(4, damage * get_pcvar_float(cvar_cowboy_dmgmult));
  }

  return HAM_HANDLED;
}

public give_knife(id, knife)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return PLUGIN_CONTINUE;

  if(is_valid_ent(knife))
    remove_entity(knife);
  new count = cvi_get_playerdata(id, PD_ITEMCOUNT);
  if(is_upgraded(id) && count < 2 || count < 1)
  {
    //pickup_weapon(id, CSW_KNIFE);
    if(!user_has_weapon(id, CSW_KNIFE))
      ham_give_weapon(id, "weapon_knife", 1);
    emit_sound(id, CHAN_WEAPON, "items/gunpickup2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM);
    set_task(0.1, "delay_deploy", id);
    cvi_set_playerdata(id, PD_ITEMCOUNT, count+1);

    return PLUGIN_HANDLED;
  }

  return PLUGIN_CONTINUE;
}

public delay_deploy(id)
{
  if(get_user_weapon(id) == CSW_KNIFE)
    show_knife(id);
}

public attack_post(id, knife, Float:flRate, Float:cvar)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  set_pdata_float(knife, m_flNextPrimaryAttack, flRate, XO_WEAPON);
  set_pdata_float(knife, m_flNextSecondaryAttack, flRate, XO_WEAPON);
  set_pdata_float(knife, m_flTimeWeaponIdle, flRate, XO_WEAPON);

  if(cvar > 0.0)
  {
    static Float:flPunchAngle[3];
    flPunchAngle[0] = cvar;

    entity_set_vector(id, EV_VEC_punchangle, flPunchAngle);
  }
}

stock a_lot_of_blood(id)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  static iOrigin[3];
  get_user_origin(id, iOrigin);

  message_begin(MSG_PVS, SVC_TEMPENTITY, iOrigin);
  write_byte(TE_BLOODSTREAM);
  write_coord(iOrigin[0]);
  write_coord(iOrigin[1]);
  write_coord(iOrigin[2]+10);
  write_coord(random_num(-360, 360));
  write_coord(random_num(-360, 360));
  write_coord(-10);
  write_byte(70);
  write_byte(random_num(50, 100));
  message_end();

  new j;
  for(j = 0; j < 4; j++) 
  {
    message_begin(MSG_PVS, SVC_TEMPENTITY, iOrigin);
    write_byte(TE_WORLDDECAL);
    write_coord(iOrigin[0]+random_num(-100, 100));
    write_coord(iOrigin[1]+random_num(-100, 100));
    write_coord(iOrigin[2]-36);
    write_byte(random_num(190, 197));
    message_end();
  }
}

stock UTIL_SetRendering(ent, kRenderFx=kRenderFxNone, {Float,_}:fVecColor[3] = {0.0,0.0,0.0}, kRender=kRenderNormal, Float:flAmount=0.0)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  if(is_valid_ent(ent))
  {
    entity_set_int(ent, EV_INT_renderfx, kRenderFx);
    entity_set_vector(ent, EV_VEC_rendercolor, fVecColor);
    entity_set_int(ent, EV_INT_rendermode, kRender);
    entity_set_float(ent, EV_FL_renderamt, flAmount);
  }
}

stock GetGrenadeType(ent)
{
  if (get_pdata_int(ent, 96) & (1<<8))
    return CSW_C4;

  new bits = get_pdata_int(ent, 114);
  if (bits & (1<<0))
    return CSW_HEGRENADE;
  else if (bits & (1<<1))
    return CSW_SMOKEGRENADE;
  else if (!bits)
    return CSW_FLASHBANG;

  return 0;
}
