#include <amxmodx>
#include <engine>
#include <cstrike>
#include <fakemeta>
#include <hamsandwich>
#include <cs_weapons_api>
#include <amx_settings_api>
#include <cvi>

#define WEAPON_CSWID CSW_DEAGLE
#define WEAPON_NAME  "weapon_deagle"

new g_szModels[6][CVI_MAXFILELENGHT];
new cvar_weapon_damage, cvar_weapon_speed, cvar_weapon_ammo, cvar_weapon_clip, cvar_weapon_damage_dual, cvar_weapon_speed_dual,
  cvar_weapon_reload, cvar_weapon_recoil;

public plugin_precache()
{
  precache_sound("weapons/bull_draw.wav");
  precache_sound("weapons/bull_reload.wav");

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Revolver", "NORMAL_MODEL_V", g_szModels[0], charsmax(g_szModels[])))
  {
    g_szModels[0] = "models/cvi/v_revolver.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Revolver", "NORMAL_MODEL_V", g_szModels[0]);
  }
  precache_model(g_szModels[0]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Revolver", "DUAL_MODEL_V", g_szModels[1], charsmax(g_szModels[])))
  {
    g_szModels[1] = "models/cvi/v_revolver_dual.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Revolver", "DUAL_MODEL_V", g_szModels[1]);
  }
  precache_model(g_szModels[1]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Revolver", "NORMAL_MODEL_P", g_szModels[2], charsmax(g_szModels[])))
  {
    g_szModels[2] = "models/cvi/p_revolver.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Revolver", "NORMAL_MODEL_P", g_szModels[2]);
  }
  precache_model(g_szModels[2]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Revolver", "DUAL_MODEL_P", g_szModels[3], charsmax(g_szModels[])))
  {
    g_szModels[3] = "models/cvi/p_revolver_dual.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Revolver", "DUAL_MODEL_P", g_szModels[3]);
  }
  precache_model(g_szModels[3]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Revolver", "NORMAL_MODEL_W", g_szModels[4], charsmax(g_szModels[])))
  {
    g_szModels[4] = "models/cvi/w_revolver.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Revolver", "NORMAL_MODEL_W", g_szModels[4]);
  }
  precache_model(g_szModels[4]);

  if(!amx_load_setting_string(CVI_SETTINGSFILE, "Revolver", "DUAL_MODEL_W", g_szModels[5], charsmax(g_szModels[])))
  {
    g_szModels[5] = "models/cvi/w_revolver_dual.mdl";
    amx_save_setting_string(CVI_SETTINGSFILE, "Revolver", "DUAL_MODEL_W", g_szModels[5]);
  }
  precache_model(g_szModels[5]);
}

public plugin_init()
{
  register_plugin("[CVI] Weapon: Revolver", CVI_VERSION, CVI_AUTHOR);

  cvar_weapon_clip        = my_register_cvar("cvi_revolver_clip", "6", "Amount of bullets in clip. (Default: 6)");
  cvar_weapon_ammo        = my_register_cvar("cvi_revolver_ammo", "32", "Amount of bullets in backpack. (Default: 32)");
  cvar_weapon_speed       = my_register_cvar("cvi_revolver_speed", "0.8", "Attack speed multiplier. (Default: 0.8)");
  cvar_weapon_speed_dual  = my_register_cvar("cvi_revolver_speed_dual", "0.7", "Attack speed multiplier for dual. (Default: 0.7)");
  cvar_weapon_damage      = my_register_cvar("cvi_revolver_damage", "0.8", "Damage multiplier. (Default: 0.8)");
  cvar_weapon_damage_dual = my_register_cvar("cvi_revolver_damage_dual", "1.2", "Damage multiplier for dual. (Default: 1.2)");
  cvar_weapon_reload      = my_register_cvar("cvi_revolver_reload", "0.0", "Additional reload time. (Default: 0.0)");
  cvar_weapon_recoil      = my_register_cvar("cvi_revolver_recoil", "0.0", "Additional recoil time. (Default: 0.0)");
}

public cvi_upgrade_class(id, player_class, val)
{
  if(cvi_get_globalinfo(GI_GAMEMODE) != GAME_STARTED)
    return;

  if(val && is_user_alive(id) && player_class == PC_COWBOY)
  {
    new ent = find_ent_by_owner(-1, WEAPON_NAME, id);
    if(is_valid_ent(ent))
    {
      set_weapon_string(ent, REPL_CSWA_MODEL_V, g_szModels[1]);
      set_weapon_string(ent, REPL_CSWA_MODEL_P, g_szModels[3]);
      set_weapon_string(ent, REPL_CSWA_MODEL_W, g_szModels[5]);

      set_weapon_float(ent, REPL_CSWA_SPEEDDELAY, get_pcvar_float(cvar_weapon_speed_dual));
      set_weapon_float(ent, REPL_CSWA_DAMAGE, get_pcvar_float(cvar_weapon_damage_dual));

      new clip = get_weapon_integer(ent, REPL_CSWA_CLIP)+get_pcvar_num(cvar_weapon_clip);
      cs_set_weapon_ammo(ent, clip);
      set_weapon_integer(ent, REPL_CSWA_CLIP, clip);
      set_weapon_integer(ent, REPL_CSWA_MAXCLIP, get_weapon_integer(ent, REPL_CSWA_MAXCLIP)*2);
      set_weapon_integer(ent, REPL_CSWA_AMMO, get_weapon_integer(ent, REPL_CSWA_AMMO)+get_pcvar_num(cvar_weapon_ammo));
      if(get_user_weapon(id) == WEAPON_CSWID)
        show_weapon(id, WEAPON_NAME);
    }
    else
    {
      static data[STOREABLE_STRUCTURE];
      if(!data[STRUCT_CSWA_CSW])
      {
        data[STRUCT_CSWA_CSW] = WEAPON_CSWID;
        data[STRUCT_CSWA_CLIP] = get_pcvar_num(cvar_weapon_clip)*2;
        data[STRUCT_CSWA_MAXCLIP] = get_pcvar_num(cvar_weapon_clip)*2;
        data[STRUCT_CSWA_AMMO] = get_pcvar_num(cvar_weapon_ammo)*2;
        data[STRUCT_CSWA_STACKABLE] = false;
        data[STRUCT_CSWA_SILENCED] = -1;
        data[STRUCT_CSWA_SPEEDDELAY] = _:get_pcvar_float(cvar_weapon_speed_dual);
        data[STRUCT_CSWA_DAMAGE] = _:get_pcvar_float(cvar_weapon_damage_dual);
        data[STRUCT_CSWA_RELOADTIME] = _:get_pcvar_float(cvar_weapon_reload);
        data[STRUCT_CSWA_RECOIL] = _:get_pcvar_float(cvar_weapon_recoil);
        data[STRUCT_CSWA_MODEL_V] = g_szModels[1];
        data[STRUCT_CSWA_MODEL_P] = g_szModels[3];
        data[STRUCT_CSWA_MODEL_W] = g_szModels[5];
      }

      cswa_give_specific(id, data);
    }
  }
}


public cvi_gamemode(mode)
{
  if(mode == GAME_STARTED)
  {
    new num, id;
    static players[32];
    get_players(players, num, "a");

    for(--num; num >= 0; num--)
    {
      id = players[num];
      if(is_cowboy(id))
        give_weap(id);
    }
  }
}

public give_weap(id)
{
  if(user_has_weapon(id, WEAPON_CSWID))
    engclient_cmd(id, "drop", WEAPON_NAME);

  static data[STOREABLE_STRUCTURE];
  if(!data[STRUCT_CSWA_CSW])
  {
    data[STRUCT_CSWA_CSW] = WEAPON_CSWID;
    data[STRUCT_CSWA_CLIP] = get_pcvar_num(cvar_weapon_clip);
    data[STRUCT_CSWA_MAXCLIP] = get_pcvar_num(cvar_weapon_clip);
    data[STRUCT_CSWA_AMMO] = get_pcvar_num(cvar_weapon_ammo);
    data[STRUCT_CSWA_STACKABLE] = false;
    data[STRUCT_CSWA_SILENCED] = -1;
    data[STRUCT_CSWA_SPEEDDELAY] = _:get_pcvar_float(cvar_weapon_speed);
    data[STRUCT_CSWA_DAMAGE] = _:get_pcvar_float(cvar_weapon_damage);
    data[STRUCT_CSWA_RELOADTIME] = _:get_pcvar_float(cvar_weapon_reload);
    data[STRUCT_CSWA_RECOIL] = _:get_pcvar_float(cvar_weapon_recoil);
    data[STRUCT_CSWA_MODEL_V] = g_szModels[0];
    data[STRUCT_CSWA_MODEL_P] = g_szModels[2];
    data[STRUCT_CSWA_MODEL_W] = g_szModels[4];
  }

  cswa_give_specific(id, data);
}
