#if defined _cvi_included
  #endinput
#endif
#define _cvi_included

#include <cvi_const> 

#if AMXX_VERSION_NUM >= 175
    #pragma reqlib cvi
    #if !defined AMXMODX_NOAUTOLOAD
        #pragma loadlib cvi
    #endif
#else
    #pragma library cvi
#endif

/**
 * Sets/gets players data.
 *
 * @param id      player index.
 * @param pd      enum PLAYER_DATA.
 * @param value   new value.
 * @return        playerdata.
 */
native cvi_get_playerdata(id, pd);
native cvi_set_playerdata(id, pd, value);

/**
 * Sets/gets globals.
 *
 * @param gi      enum GLOBAL_INFO.
 * @param value   new value.
 * @return        globalinfo.
 */
native cvi_get_globalinfo(gi);
native cvi_set_globalinfo(gi, value);

/**
 * Sets/gets winner.
 *
 * @param value   sets new winner.
 * @return        winner.
 */
native cvi_get_winner();
native cvi_set_winner(value);

/**
 * Gets roundtime.
 *
 * @return       roundtime.
 */
native Float:cvi_get_roundtime();

/**
 * Register cvar to file.
 *
 * @param name[]        Cvar name.
 * @param string[]      Cvar value.
 * @param description[] Cvar description.
 * @return              true/false.
 */
native cvi_register_cvar(name[], string[], description[]);

/**
 * Called when game state changes.
 *
 * @param mode     Gamestate.
 */
forward cvi_gamemode(mode);

/**
 * Called when winner is set.
 *
 * @param winner   Winner.
 */
forward cvi_winner(winner);

#include <cvi_stocks>
